<?php
  if( ! function_exists('twe_draw_hidden_field') ) {
    require_once(DIR_FS_INC . 'twe_draw_hidden_field.inc.php');
  }

  require_once( dirname(__FILE__).'/openpay/openpay_main.php' );

  class openpay_ccard06 {
    var $code, $title, $description, $enabled;

// class constructor
    public function openpay_ccard06() {
      global $order;

      $this->code = 'openpay_ccard06';
      $this->title = MODULE_PAYMENT_OPENPAY_CCARD06_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_OPENPAY_CCARD06_TEXT_DESC;
      $this->sort_order = MODULE_PAYMENT_OPENPAY_CCARD06_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_OPENPAY_CCARD06_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_OPENPAY_CCARD06_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_OPENPAY_CCARD06_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      $this->form_action_url = openpay_main::get_form_action_url();
      $this->prefer_paymethod = 1;
      $this->iid = 6;
    }

// class methods
    public function update_status() {
      global $order, $db;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_OPENPAY_CCARD06_ZONE > 0) ) {
        $check_flag = false;
        $check_query = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_OPENPAY_CCARD06_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while (!$check->EOF) {
          if ($check->fields['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check->fields['zone_id'] == $order->delivery['zone_id']) {
            $check_flag = true;
            break;
          }
          $check->MoveNext();
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    public function javascript_validation() {
      return false;
    }

    public function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    public function pre_confirmation_check() {
      // save paymethod/iid for ot_openpaysr.php
      $_SESSION['MODULE_ORDER_TOTAL_OPENPAYSR_PAYMETHOD'] = $this->prefer_paymethod;
      $_SESSION['MODULE_ORDER_TOTAL_OPENPAYSR_IID'] = $this->iid;

      return false;
    }

    public function confirmation() {
      return false;
    }

    public function process_button() {
      global $order, $language;

      $return_url = twe_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL');

      // get request parameter
      $req_params = openpay_main::get_request_parameter( $this->prefer_paymethod, $this->iid, $return_url, $order, $language );

      // render form elements
      $process_button_string = '';
      foreach( $req_params as $name => $value ) {
        $process_button_string .= "\n".twe_draw_hidden_field( $name, $value );
      }

      return $process_button_string;
    }

    public function before_process() {
      global $order;

      openpay_main::do_response_process( $_POST, $order, $this->code );

      return false;
    }

    public function after_process() {
      return false;
    }

    public function get_error() {
      return openpay_main::get_error( $_GET['error'], $_GET['error_desc'] );
    }

    public function check() {
      global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_OPENPAY_CCARD06_STATUS'");
        $this->_check = $check_query->RecordCount();
      }
      return $this->_check;
    }

    public function install() {
      global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added) values ('MODULE_PAYMENT_OPENPAY_CCARD06_STATUS', 'True', '6', '18', 'twe_cfg_select_option(array(\'True\', \'False\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, set_function, date_added) values ('MODULE_PAYMENT_OPENPAY_CCARD06_ZONE', '0', '6', '18', 'twe_get_zone_class_title', 'twe_cfg_pull_down_zone_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_OPENPAY_CCARD06_SORT_ORDER', '0', '6', '18', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_OPENPAY_CCARD06_ORDER_STATUS_ID', '0', '6', '18', 'twe_cfg_pull_down_order_statuses(', 'twe_get_order_status_name', now())");
   	  $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_OPENPAY_CCARD06_ALLOWED', '', '6', '0', now())");
    }

    public function remove() {
      global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    public function keys() {
      return array('MODULE_PAYMENT_OPENPAY_CCARD06_STATUS', 'MODULE_PAYMENT_OPENPAY_CCARD06_ZONE', 'MODULE_PAYMENT_OPENPAY_CCARD06_SORT_ORDER', 'MODULE_PAYMENT_OPENPAY_CCARD06_ORDER_STATUS_ID', 'MODULE_PAYMENT_OPENPAY_CCARD06_ALLOWED');
    }
  }
