<?php
  class openpaypcsc {
    var $code, $title, $description, $icon, $enabled;

    public function openpaypcsc() {
      global $order, $db;;

      $this->code = 'openpaypcsc';
      $this->title = MODULE_SHIPPING_OPENPAYPCSC_TEXT_TITLE;
      $this->description = MODULE_SHIPPING_OPENPAYPCSC_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_SHIPPING_OPENPAYPCSC_SORT_ORDER;
      $this->icon = '';
      $this->tax_class = MODULE_SHIPPING_OPENPAYPCSC_TAX_CLASS;
      $this->enabled = ((MODULE_SHIPPING_OPENPAYPCSC_STATUS == 'True') ? true : false);

      if ( ($this->enabled == true) && ((int)MODULE_SHIPPING_OPENPAYPCSC_ZONE > 0) ) {
        $check_flag = false;
        $check = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_SHIPPING_OPENPAYPCSC_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
        while (!$check->EOF) {
          if ($check->fields['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check->fields['zone_id'] == $order->delivery['zone_id']) {
            $check_flag = true;
            break;
          }
      		$check->MoveNext();
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }


    public function quote($method = '') {
      global $order;

      $this->quotes = array('id' => $this->code,
                            'module'  => MODULE_SHIPPING_OPENPAYPCSC_TEXT_TITLE,
                            'methods' => array(array('id' => $this->code,
                            'title'   => MODULE_SHIPPING_OPENPAYPCSC_TEXT_WAY,
                            'cost'    => MODULE_SHIPPING_OPENPAYPCSC_COST)));

      if ($this->tax_class > 0) {
        $this->quotes['tax'] = twe_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
      }

      if (twe_not_null($this->icon)) $this->quotes['icon'] = twe_image($this->icon, $this->title);

      return $this->quotes;
    }

    public function check() {
    	global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_SHIPPING_OPENPAYPCSC_STATUS'");
        $this->_check = $check_query->RecordCount();
      }
      return $this->_check;
    }

    public function install() {
    	global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, date_added) values ('MODULE_SHIPPING_OPENPAYPCSC_STATUS', 'True', '6', '0', 'twe_cfg_select_option(array(\'True\', \'False\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_SHIPPING_OPENPAYPCSC_ALLOWED', '', '6', '0', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_SHIPPING_OPENPAYPCSC_COST', '60', '6', '0', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, use_function, set_function, date_added) values ('MODULE_SHIPPING_OPENPAYPCSC_TAX_CLASS', '0', '6', '0', 'twe_get_tax_class_title', 'twe_cfg_pull_down_tax_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, use_function, set_function, date_added) values ('MODULE_SHIPPING_OPENPAYPCSC_ZONE', '0', '6', '0', 'twe_get_zone_class_title', 'twe_cfg_pull_down_zone_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_SHIPPING_OPENPAYPCSC_SORT_ORDER', '0', '6', '0', now())");
    }

    public function remove() {
    	global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    public function keys() {
      return array('MODULE_SHIPPING_OPENPAYPCSC_STATUS', 'MODULE_SHIPPING_OPENPAYPCSC_COST','MODULE_SHIPPING_OPENPAYPCSC_ALLOWED', 'MODULE_SHIPPING_OPENPAYPCSC_TAX_CLASS', 'MODULE_SHIPPING_OPENPAYPCSC_ZONE', 'MODULE_SHIPPING_OPENPAYPCSC_SORT_ORDER');
    }
  }
